from pytest_common import pytest, run


@pytest.mark.parametrize(
    "edges, pair, is_connected",
    [
        [
            [('markers', 'jumping'), ('jumping', 'guinea'), ('skiing', 'pre'),
             ('markers', 'gauge'), ('skiing', 'mpeg'), ('solar', 'jackson'),
             ('skiing', 'solar'), ('guinea', 'gauge'), ('mpeg', 'honor'),
             ('pre', 'honor'), ('guinea', 'gauge'), ('pre', 'mpeg'),
             ('markers', 'guinea'), ('markers', 'gauge'), ('honor', 'mpeg'),
             ('markers', 'jumping')],
            ('skiing', 'jumping'), False
        ],
        [
            [('gnome', 'str'), ('edt', 'rover'), ('sports', 'lil'),
             ('dis', 'gnome'), ('str', 'drove'), ('gnome', 'locking'),
             ('craft', 'rover'), ('safer', 'craft'), ('locking', 'poem'),
             ('safer', 'trainer'), ('locking', 'sports'), ('ethnic', 'dis'),
             ('fits', 'drove'), ('trainer', 'poem'), ('dis', 'gnome'),
             ('ethnic', 'edt')],
            ('drove', 'str'), True
        ],
        [
            [('citizen', 'flowers'), ('probe', 'yarn'), ('yarn', 'pupils'),
             ('boxed', 'dollars'), ('trick', 'healing'), ('tall', 'wanting'),
             ('probe', 'media'), ('pupils', 'media'), ('pupils', 'yarn'),
             ('probe', 'trick'), ('tall', 'nuke'), ('yarn', 'nuke'),
             ('buffalo', 'wanting'), ('flowers', 'dollars'),
             ('buffalo', 'citizen')],
            ('trick', 'gloves'), False
        ],
        [
            [('sign', 'builder'), ('abc', 'jake'), ('sign', 'builder'),
             ('very', 'dee'), ('jake', 'abc'), ('gmc', 'export'),
             ('jake', 'abc'), ('dee', 'very'), ('very', 'dee'),
             ('export', 'gmc'), ('largest', 'unified'), ('jake', 'abc'),
             ('unified', 'largest'), ('jake', 'abc'), ('abc', 'jake'),
             ('abc', 'jake'), ('unified', 'largest'), ('very', 'dee'),
             ('builder', 'sign'), ('sign', 'builder'), ('sign', 'builder'),
             ('unified', 'largest'), ('unified', 'largest'),
             ('builder', 'sign'), ('builder', 'sign'), ('sign', 'builder'),
             ('gmc', 'export'), ('export', 'gmc'), ('jake', 'abc'),
             ('sign', 'builder'), ('unified', 'largest'), ('very', 'dee'),
             ('sign', 'builder'), ('dee', 'very'), ('abc', 'jake'),
             ('dee', 'very'), ('dee', 'very'), ('jake', 'abc'),
             ('abc', 'jake'), ('export', 'gmc'), ('jake', 'abc'),
             ('gmc', 'export'), ('gmc', 'export'), ('very', 'dee'),
             ('largest', 'unified'), ('dee', 'very'), ('largest', 'unified'),
             ('abc', 'jake'), ('unified', 'largest'), ('unified', 'largest'),
             ('largest', 'unified'), ('export', 'gmc'), ('very', 'dee'),
             ('gmc', 'export'), ('very', 'dee'), ('export', 'gmc'),
             ('largest', 'unified'), ('largest', 'unified'), ('abc', 'jake'),
             ('very', 'dee'), ('very', 'dee'), ('jake', 'abc'),
             ('builder', 'sign'), ('unified', 'largest'), ('export', 'gmc'),
             ('unified', 'largest'), ('very', 'dee'), ('export', 'gmc'),
             ('jake', 'abc'), ('sign', 'builder'), ('unified', 'largest'),
             ('unified', 'largest'), ('export', 'gmc'), ('abc', 'jake'),
             ('unified', 'largest'), ('very', 'dee'), ('sign', 'builder'),
             ('builder', 'sign'), ('export', 'gmc'), ('largest', 'unified'),
             ('builder', 'sign'), ('abc', 'jake'), ('sign', 'builder'),
             ('unified', 'largest'), ('abc', 'jake'), ('unified', 'largest'),
             ('jake', 'abc'), ('dee', 'very'), ('gmc', 'export'),
             ('export', 'gmc'), ('gmc', 'export'), ('export', 'gmc'),
             ('largest', 'unified'), ('builder', 'sign'), ('dee', 'very'),
             ('very', 'dee'), ('sign', 'builder'), ('dee', 'very'),
             ('gmc', 'export'), ('unified', 'largest'), ('very', 'dee'),
             ('abc', 'jake'), ('export', 'gmc'), ('abc', 'jake'),
             ('abc', 'jake'), ('abc', 'jake'), ('abc', 'jake'),
             ('gmc', 'export'), ('dee', 'very'), ('gmc', 'export'),
             ('unified', 'largest'), ('export', 'gmc'), ('dee', 'very'),
             ('sign', 'builder'), ('dee', 'very'), ('builder', 'sign'),
             ('unified', 'largest'), ('abc', 'jake'), ('very', 'dee'),
             ('sign', 'builder'), ('dee', 'very'), ('largest', 'unified'),
             ('very', 'dee'), ('jake', 'abc'), ('very', 'dee'),
             ('sign', 'builder'), ('export', 'gmc'), ('largest', 'unified'),
             ('abc', 'jake'), ('jake', 'abc'), ('abc', 'jake'),
             ('gmc', 'export'), ('unified', 'largest'), ('unified', 'largest'),
             ('export', 'gmc'), ('dee', 'very'), ('builder', 'sign'),
             ('unified', 'largest'), ('largest', 'unified'),
             ('largest', 'unified'), ('export', 'gmc'), ('jake', 'abc'),
             ('export', 'gmc'), ('gmc', 'export'), ('sign', 'builder'),
             ('very', 'dee'), ('builder', 'sign'), ('abc', 'jake'),
             ('gmc', 'export'), ('jake', 'abc'), ('sign', 'builder'),
             ('sign', 'builder'), ('builder', 'sign'), ('sign', 'builder'),
             ('builder', 'sign'), ('largest', 'unified'), ('abc', 'jake'),
             ('unified', 'largest'), ('jake', 'abc'), ('very', 'dee'),
             ('abc', 'jake'), ('sign', 'builder'), ('builder', 'sign'),
             ('very', 'dee'), ('export', 'gmc'), ('very', 'dee'),
             ('largest', 'unified'), ('unified', 'largest'),
             ('unified', 'largest'), ('abc', 'jake'), ('export', 'gmc'),
             ('gmc', 'export'), ('abc', 'jake'), ('gmc', 'export'),
             ('export', 'gmc'), ('export', 'gmc'), ('sign', 'builder'),
             ('builder', 'sign'), ('unified', 'largest'), ('builder', 'sign'),
             ('largest', 'unified'), ('builder', 'sign'), ('abc', 'jake'),
             ('dee', 'very'), ('very', 'dee'), ('builder', 'sign'),
             ('very', 'dee'), ('sign', 'builder'), ('very', 'dee'),
             ('export', 'gmc'), ('very', 'dee'), ('builder', 'sign'),
             ('gmc', 'export'), ('very', 'dee'), ('abc', 'jake'),
             ('export', 'gmc'), ('dee', 'very'), ('largest', 'unified'),
             ('sign', 'builder'), ('gmc', 'export')],
            ('unified', 'sign'), False
        ],
        [
            [('indian', 'silicon'), ('howard', 'park'), ('hints', 'gadgets'),
             ('aaron', 'spaces'), ('reid', 'boston'), ('dover', 'export'),
             ('ideal', 'fotos'), ('button', 'school'), ('sega', 'since'),
             ('park', 'journal'), ('tion', 'back'), ('float', 'ship'),
             ('philip', 'feb'), ('unified', 'philip'), ('lending', 'sega'),
             ('fault', 'ideal'), ('pac', 'park'), ('joint', 'button'),
             ('button', 'firms'), ('geo', 'since'), ('cyprus', 'gsm'),
             ('cancer', 'throw'), ('optics', 'penalty'), ('feb', 'basics'),
             ('wise', 'martha'), ('gadgets', 'rod'), ('rough', 'dover'),
             ('jar', 'unified'), ('framing', 'float'), ('expect', 'steve'),
             ('martha', 'forming'), ('locally', 'votes'), ('rough', 'silicon'),
             ('tulsa', 'rough'), ('hourly', 'cut'), ('sox', 'levy'),
             ('aaron', 'corner'), ('muscles', 'printed'), ('solaris', 'ship'),
             ('geo', 'framing'), ('made', 'six'), ('ideal', 'levy'),
             ('ears', 'fotos'), ('howard', 'costa'), ('deluxe', 'pac'),
             ('penalty', 'votes'), ('feb', 'ears'), ('gsm', 'bend'),
             ('school', 'sec'), ('steve', 'pest'), ('tulsa', 'brands'),
             ('ship', 'boston'), ('voting', 'levy'), ('wise', 'reid'),
             ('reward', 'costa'), ('aaron', 'video'), ('scratch', 'parents'),
             ('serial', 'forming'), ('spaces', 'bend'), ('rat', 'retail'),
             ('eng', 'school'), ('optics', 'defines'), ('gadgets', 'made'),
             ('cove', 'aaron'), ('rubber', 'object'), ('feb', 'basics'),
             ('dover', 'martha'), ('basics', 'cove'), ('reid', 'kind'),
             ('hourly', 'tobacco'), ('fotos', 'made'), ('unified', 'back'),
             ('eng', 'bend'), ('throw', 'joint'), ('optics', 'martha'),
             ('brands', 'steve'), ('wise', 'char'), ('video', 'bend'),
             ('refers', 'cyprus'), ('cancer', 'ohio'), ('sparc', 'suits'),
             ('holy', 'kind'), ('undo', 'penalty'), ('expect', 'framing'),
             ('malta', 'reward'), ('export', 'locally'), ('geo', 'disable'),
             ('defines', 'levy'), ('tion', 'sega'), ('tion', 'pac'),
             ('sega', 'scratch'), ('sec', 'logic'), ('daisy', 'tulsa'),
             ('logic', 'rat'), ('liberal', 'indian'), ('jar', 'video'),
             ('kind', 'rod'), ('voting', 'retail'), ('muscles', 'tobacco'),
             ('indian', 'gsm'), ('bennett', 'hourly'), ('holy', 'retail'),
             ('printed', 'sox'), ('cut', 'firms'), ('locally', 'cyprus'),
             ('holy', 'expect'), ('kind', 'joint'), ('reward', 'ears'),
             ('corner', 'throw'), ('suits', 'lending'), ('jar', 'solaris'),
             ('object', 'hints'), ('logic', 'defines'), ('rebate', 'rubber'),
             ('liberal', 'pac'), ('cyprus', 'park'), ('sec', 'rat'),
             ('sparc', 'forming'), ('parents', 'liberal'), ('indian', 'wise'),
             ('scratch', 'cut'), ('export', 'suits'), ('menus', 'object'),
             ('tribe', 'export'), ('ears', 'malta'), ('hints', 'fault'),
             ('daisy', 'liberal'), ('howard', 'rebate'), ('char', 'scratch'),
             ('cove', 'tion'), ('six', 'suits'), ('muscles', 'video'),
             ('joint', 'undo'), ('printed', 'firms'), ('disable', 'since'),
             ('rough', 'brands'), ('burns', 'philip'), ('deluxe', 'boston'),
             ('spaces', 'parents'), ('since', 'burns'), ('undo', 'back'),
             ('hints', 'made'), ('menus', 'costa'), ('cancer', 'unified'),
             ('optics', 'votes'), ('solaris', 'fotos'), ('ideal', 'muscles'),
             ('pest', 'bennett'), ('jar', 'geo'), ('burns', 'reward'),
             ('rebate', 'holy'), ('tion', 'howard'), ('votes', 'logic'),
             ('solaris', 'six'), ('penalty', 'firms'), ('tribe', 'pac'),
             ('deluxe', 'bennett'), ('tobacco', 'steve'), ('char', 'float'),
             ('reid', 'ship'), ('serial', 'lending'), ('brands', 'fault'),
             ('object', 'rod'), ('tulsa', 'tribe'), ('spaces', 'tribe'),
             ('printed', 'refers'), ('journal', 'pac'), ('defines', 'six'),
             ('school', 'daisy'), ('boston', 'dover'), ('back', 'rod'),
             ('expect', 'corner'), ('button', 'disable'), ('tobacco', 'sox'),
             ('tion', 'voting'), ('lending', 'pest'), ('corner', 'deluxe'),
             ('hourly', 'sparc'), ('undo', 'sparc'), ('parents', 'rubber'),
             ('cut', 'cove'), ('gadgets', 'forming'), ('silicon', 'ohio'),
             ('gsm', 'rebate'), ('journal', 'serial'), ('menus', 'journal'),
             ('throw', 'pest'), ('eng', 'menus'), ('fault', 'ohio'),
             ('serial', 'silicon'), ('rat', 'refers'), ('basics', 'sec'),
             ('refers', 'sox'), ('framing', 'malta'), ('rubber', 'locally'),
             ('cancer', 'philip'), ('cove', 'burns'), ('deluxe', 'eng'),
             ('ohio', 'char'), ('retail', 'costa'), ('malta', 'voting')],
            ('retail', 'deluxe'), True
        ]
    ]
)
def test_dungeonmap(edges, pair, is_connected):
    result = run(
        __file__, 'solution.py',
        input='\n'.join(' '.join(edge) for edge in edges) + '\n' +
              '\n'.join(pair)
    )
    assert result.returncode == 0, result.stderr
    assert result.stdout.strip() == ("YES" if is_connected else "NO")
